
function draws = DrawQ(Z, f, number_draws)

% number variables
n=numel(Z);

% restricted columns
k=0;
restricted=zeros(n,1);
for ii=1:n
    if size(Z{ii},1) > 0
        k=k+1;
        restricted(k)=ii;
    end
end
restricted=restricted(1:k);

% unrestricted columns
unrestricted=zeros(n-k,1);
jj=0;
for ii=1:n
    if size(Z{ii},1) == 0
        jj=jj+1;
        unrestricted(jj)=ii;
    end
end

draws=cell(number_draws,1);
Q=zeros(n,n);
for mm=1:number_draws
    
    % initialize Gibbs
    for ii=1:k
        N=null([Z{restricted(ii)}*f; Q(:,restricted(1:ii-1))']);
        q=N*randn(size(N,2),1);
        Q(:,restricted(ii))=q/norm(q);
    end
    
    
    % conditional draws
    N=null(Q(:,restricted)');
    x=N*randn(size(N,2),n-k);
    [q, r]=qr(x,0);
    Q(:,unrestricted)=q*diag(sign(diag(r)));    % this makes the diagonal of r positive
    
    % save draw
    draws{mm} =Q;
end

