function z = OrthogonalRestrictions(x, Z_IRF, nvar)
%
% zero restrictions on Q=reshape(x,nvar,nar), which are of the form
%
%   Z_IRF{i}*Q(:i,i) = 0
%
% and the restrictions that Q be orthogonal.
%

% total number of restrictions
total_zeros=nvar*(nvar+1)/2;
for j=1:nvar
    total_zeros=total_zeros+size(Z_IRF{j},1);
end

% restrictions
Q = reshape(x,nvar,nvar);
z=zeros(total_zeros,1);
k=1;
for i=1:nvar
    s=size(Z_IRF{i},1);
    if s > 0
        z(k:k+s-1)=Z_IRF{i}*Q(:,i);
        k=k+s;
    end
    z(k)=Q(:,i)'*Q(:,i) - 1.0;
    k=k+1;
    for j=i+1:nvar
        z(k)=Q(:,i)'*Q(:,j);
        k=k+1;
    end
end