function y = StructuralToReducedForm(x,h,n,m)

% x is the "vectorized" structural parameterization
% x = [ reshape(A0,n*n,1); reshape(Aplus,m*n,1) ];

A0      = reshape(x(1:n*n),n,n);
Aplus   = reshape(x(n*n+1:end),m,n);

B       = Aplus/A0;
Sigma   = inv(A0*A0');
Q       = h(Sigma)*A0;

y = [ reshape(B,m*n,1); reshape(Sigma,n*n,1); reshape(Q,n*n,1) ];   % y is the "vertorized" orthogonal reduced-form parameterization
