
function FEV_h_i = variancedecomposition_LIRF(LIRF,h,shock_i)
%This function computes the variance decomposition of a VAR model

n           = size(LIRF,2);

MSE_h_all   = zeros(n,n);
MSE_h_i     = zeros(n,n);

for t = 0:h
    
    IRF_h_all   = LIRF( 1+t*n:(t+1)*n, : );
    MSE_h_all   = MSE_h_all + (IRF_h_all)*(IRF_h_all');
    
    IRF_h_i     = IRF_h_all( :, shock_i );
    MSE_h_i     = MSE_h_i + (IRF_h_i)*(IRF_h_i');
      
end

MSE_h_all_diag = diag(MSE_h_all);
MSE_h_i_diag   = diag(MSE_h_i);

FEV_h_i = MSE_h_i_diag ./ MSE_h_all_diag;



