function [ ve_fh_out1, ve_fh_out2 ] = ve_fh(Bdraw,Sigmadraw)


global Z m n p ns;

ve_fh_out1 = zeros(ns,1);
ve_fh_out2 = zeros(ns,1);

%% set functions
hh=@chol;
fh_inv               = @(x)ReducedFormToStructural(x,hh,n,m);
fh_inv_restrictions  = @(x)ReducedFormRestrictions(x,Z);
fh                   = @(y)StructuralToReducedForm(y,hh,n,m);
% structural parameters for the zero restrictions
x=[reshape(Bdraw,m*n,1); reshape(Sigmadraw,n*n,1); reshape(eye(n),n*n,1)];
horizons= 0;
% computes the dimension of space in which the spheres live that map into the
% orthogonal matrices satisfying the restriction.
dim=0;
for i=1:n
    dim=dim+n-(i-1+size(Z{i},1));
end
% IRF restrictions
IRF=IRF_horizons(x,n,p,m,horizons);
Z_IRF=cell(n,1);
for j=1:n
    Z_IRF{j} = Z{j}*IRF;
end
f = @(x)SpheresToQ(x,Z_IRF,n);

% first compute the volume element v_fh(fh_inv(Bdraw,Sigmadraw,Qdraw))
for ii=1:ns
    
    
    % form element of R^dim that maps into orthogonal matrix
    q_tilde=randn(dim,1);
    k=0;
    for i=1:n
        s=n-(i-1+size(Z{i},1));
        qi=q_tilde(k+1:k+s);
        q_tilde(k+1:k+s)=qi/norm(qi);
        k=k+s;
    end
    Q=f(q_tilde);
    
    
    
    %% vectorize reduced form parameters (B,Sigma,Q)
    x=[reshape(Bdraw,m*n,1); reshape(Sigmadraw,n*n,1); Q];
   
    % volume element of fh
    ve1 = LogVolumeElement(fh,fh_inv(x));
    ve2 = LogVolumeElement(fh_inv,x,fh_inv_restrictions);
    

    
    
    ve_fh_out1(ii,1) = ve1;
    ve_fh_out2(ii,1) = -ve2;
    

    
end




end

