function y = ReducedFormToStructural(x,h,n,m)

% x is the "vertorized" orthogonal reduced-form parameterization
% x = [ reshape(Bdraw,m*n,1); reshape(Sigmadraw,n*n,1); reshape(Qdraw,n*n,1) ];

B       = reshape(x(1:m*n),m,n);
Sigma   = reshape(x(m*n+1:(m+n)*n),n,n);
Q       = reshape(x((m+n)*n+1:end),n,n);

A0      = h(0.5*(Sigma + Sigma'))\Q;                    % A0 = inv(h(Sigma))*Q; h(X) = chol(X) produces an upper triangular matrix, R such that R'R = X
Aplus   = B*A0;

y       = [ reshape(A0,n*n,1); reshape(Aplus,m*n,1) ];  % y is the "vectorized" structural parameterization
