function [ ve_g_out1,ve_g_out2] = ve_g(Bdraw,Sigmadraw)

global Z m n p ns;

ve_g_out1 = zeros(ns,1);
ve_g_out2 = zeros(ns,1);

% structural parameters for the zero restrictions
x=[reshape(Bdraw,m*n,1); reshape(Sigmadraw,n*n,1); reshape(eye(n),n*n,1)];
    
horizons= 0;

% computes the dimension of space in which the spheres live that map into the
% orthogonal matrices satisfying the restriction.
dim=0;
for i=1:n
    dim=dim+n-(i-1+size(Z{i},1));
end


% IRF restrictions
IRF=IRF_horizons(x,n,p,m,horizons);
Z_IRF=cell(n,1);
for j=1:n
    Z_IRF{j} = Z{j}*IRF;
end

f = @(x)SpheresToQ(x,Z_IRF,n);
f_restrictions=@(x)SpheresRestriction(x,Z_IRF,n);
f_inv=@(x)QToSpheres(x,Z_IRF,n);
f_inv_restrictions=@(x)OrthogonalRestrictions(x,Z_IRF,n);
    
% first compute the volume element v_fh(fh_inv(Bdraw,Sigmadraw,Qdraw))
for ii=1:ns
    
    
    % form element of R^dim that maps into orthogonal matrix
    q_tilde=randn(dim,1);
    k=0;
    for i=1:n
        s=n-(i-1+size(Z{i},1));
        qi=q_tilde(k+1:k+s);
        q_tilde(k+1:k+s)=qi/norm(qi);
        k=k+s;
    end
    Q=f(q_tilde);
    

    % volume elements
    ve=LogVolumeElement(f,q_tilde,f_restrictions);
    ive=LogVolumeElement(f_inv,Q,f_inv_restrictions);
     
    ve_g_out1(ii,1) =  ve;
    ve_g_out2(ii,1) =  -ive;
    
    
end




